
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Python ORM框架SQLAlchemy学习笔记之数据添加和事务回滚介绍_python / iVAN</title>

    <meta name="description" content="Python ORM框架SQLAlchemy学习笔记之数据添加和事务回滚介绍_python 1. 添加一个新对象 前面介绍了映射到实体表的映射类User,如果我们想将其持久化(Persist),那么就需要将这个由User类建立的对象实例添加到我们先前创建的Session会话实例中: 复制代码 代码如下: ed_user = User('ed', 'Ed Jones', 'edspassword')session.add(ed_user) 上面两段代码执行完后对象持久化了么?你或许会兴冲冲的跑去数据库里查看,结果却失望而归--数据库里什么都没有.为什么呢?因为SQLAlchemy采取的是">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Python ORM框架SQLAlchemy学习笔记之数据添加和事务回滚介绍_python</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>1. 添加一个新对象</strong></p>
<p>前面介绍了映射到实体表的映射类User，如果我们想将其持久化(Persist)，那么就需要将这个由User类建立的对象实例添加到我们先前创建的Session会话实例中：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>ed_user = User('ed', 'Ed Jones', 'edspassword')<br />session.add(ed_user)</p>
<p>上面两段代码执行完后对象持久化了么？你或许会兴冲冲的跑去数据库里查看，结果却失望而归——数据库里什么都没有。为什么呢？因为SQLAlchemy采取的是Lazyload策略，也就是说现在这个对象被标记为Pending准备状态，但没有执行任何可能导致数据库变化的SQL语句。那么什么时候会执行SQL语句并真正持久化呢？这个要等SQLAlchemy觉得需要的时候，比如我们现在查询这个对象、对象的一个属性或者显式的调用flush方法，这时候SQLAlchemy觉得它“是时候”或者“不得不”执行SQL数据库查询以便于把标记为Pending的数据写入数据库表中了。假如这时候你执行的获取对象、对象属性或者类似的操作，SQLAlchemy在执行完SQL语句后会将你所要查询的数据反馈给你。<br />
<br />为了更好的说明这一点，这里举一个例子，这里涉及到我们第一个查询示例，我们调用了Query对象来帮助我们完成这些，比如这里我们获取刚刚持久化的用户ed，我们通过“过滤(filter by)”的方式来查询用户名为ed的用户，当然我们只需要一个ed，假如有多个重名的ed的话，查询将会返回所有叫ed的记录集列表，我们就选择第一个ed吧(first)。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; our_user = session.query(User).filter_by(name='ed').first() <br />BEGIN (implicit)<br />INSERT INTO users (name, fullname, password) VALUES (?, ?, ?)<br />('ed', 'Ed Jones', 'edspassword')<br />SELECT users.id AS users_id,<br />        users.name AS users_name,<br />        users.fullname AS users_fullname,<br />        users.password AS users_password<br />FROM users<br />WHERE users.name = ?<br /> LIMIT ? OFFSET ?<br />('ed', 1, 0)<br />&gt;&gt;&gt; our_user<br />&lt;User('ed','Ed Jones', 'edspassword')&gt;</p>
<p>可以看到上面的查询语句返回了一个User的实例，而这个实例恰恰是我们先前持久化的。同时由于我们指定了引擎的echo=True，所以再执行查询时输出了SQL语句，我们注意到除了普通的SELECT外，还有额外的INSERT语句，而INSERT处理的就是我们刚刚通过session.add()持久化标记为Pending的对象，也就是说你在实际操作持久化数据时才会由延迟加载(lazyload)真正触发数据库操作。<br />
<br />实际上Session查询反馈给我们的User对象和我们刚刚持久化的对象是同一个对象，通过下面的代码可以检验：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; ed_user is our_user<br />True</p>
<p>实际上这里ORM的操作概念有点类似于标识映射(identity map)，也就是说在实体数据库之前架设一张标识映射表，可以看作缓存表的一种，任何存储数据库的对象会事先停留在这张表上，如果我们要查询一个对象，将事先查询这张标识映射表，如果这个对象存在则直接取出，否则就会查询实体数据库，我觉得这个有点像缓存的作用，可以这么理解吧。<br />
<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE0NjEwMTA1MDMyNjY5LnBuZw==.jpg"><br />一旦一个带有独一无二的主键的对象被Session持久化了，所有使用该主键在同一Session上查询的对象将是同一个Python对象。当然对于在这个会话中持久化另外一个具有相同主键的对象将会抛出异常错误（主键不能重复）。</p>
<p>如果我们想一次性添加多个对象到Session中可以调用add_all()：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.add_all([<br />...     User('wendy', 'Wendy Williams', 'foobar'),<br />...     User('mary', 'Mary Contrary', 'xxg527'),<br />...     User('fred', 'Fred Flinstone', 'blah')])</p>
<p>下面再谈谈修改，假如Ed觉得他的密码不太安全，决定修改，可以直接这么做：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; ed_user.password = 'f8s7ccs'</p>
<p>同样的道理，这个改动不会立即反映到数据库里，当然Session意识到你要修改Ed的密码，它会暂时缓冲这个改动，我们可以通过dirty方法了解到我们的改动：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.dirty<br />IdentitySet([&lt;User('ed','Ed Jones', 'f8s7ccs')&gt;])</p>
<p>同样的我们可以通过new方法“窥看”到先前用add_all()持久化的对象列表：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.new  <br />IdentitySet([&lt;User('wendy','Wendy Williams', 'foobar')&gt;,<br />&lt;User('mary','Mary Contrary', 'xxg527')&gt;,<br />&lt;User('fred','Fred Flinstone', 'blah')&gt;])</p>
<p>当然这些改动都没有真正反馈到数据库里，相当于都被ORM缓冲了。接下来我们可以显式的调用commit()来告诉Session：“我们目前就添加或者改动这么多可以提交数据库了”：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.commit()<br />UPDATE users SET password=? WHERE users.id = ?<br />('f8s7ccs', 1)<br />INSERT INTO users (name, fullname, password) VALUES (?, ?, ?)<br />('wendy', 'Wendy Williams', 'foobar')<br />INSERT INTO users (name, fullname, password) VALUES (?, ?, ?)<br />('mary', 'Mary Contrary', 'xxg527')<br />INSERT INTO users (name, fullname, password) VALUES (?, ?, ?)<br />('fred', 'Fred Flinstone', 'blah')<br />COMMIT</p>
<p>于是刚才缓冲的数据或者变更全部被作为事务一次性flush到数据库了，通过输出的SQL语句我们也可以看出来。<br />
<br />这个操作完成后被会话(Session)引用的数据库连接资源将被回收到连接池中，接下来的对于这个Session的任何操作将会触发一个新的事务(Transaction)，当然会再次和连接池申请获得数据库连接资源。</p>
<p>之前文章介绍到Ed的User对象的id为None，现在让我们来看看吧：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; ed_user.id <br />BEGIN (implicit)<br />SELECT users.id AS users_id,<br />        users.name AS users_name,<br />        users.fullname AS users_fullname,<br />        users.password AS users_password<br />FROM users<br />WHERE users.id = ?<br />(1,)<br />1</p>
<p>除了由于echo=True导致输出的SQL语句，看看是不是有了值，值为1。<br />
<br />无论是立即(commit、flush)或者通过“首次访问加载(load-on-first-access)”，在Session在数据库插入一条新记录后，所有新生成的标识和数据库生成的默认值对于实例来说才可以被访问到。</p>
<p>当调用了commit()以后，SQLAlchemy将会刷新当前事务的所有数据到数据库里。</p>
<p><strong>2. 事务回滚</strong></p>
<p>本文以及同系列的文章是以自己的想法翻译的，不当之处还请指正，不做权威依据。好了，下面我还是简单介绍一下事务回滚吧，其实这个和数据库的事务回滚一个意思，就是我们做错事后要撤消之前的变更。</p>
<p>因为Session是作为事务(transaction)来工作的，所以我们可以回滚(roll back)先前所做的更改。接下来让我们做两个稍后会被撤销(回滚)的更改，第一个是修改ed_user.name：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; ed_user.name = 'Edwardo'</p>
<p>第二个是增加一个“不期望”的用户fake_user：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; fake_user = User('fakeuser', 'Invalid', '12345')<br />&gt;&gt;&gt; session.add(fake_user)</p>
<p>查询当前会话，我们可以看到这两个变更已经被flush到当前事务里了：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.query(User).filter(User.name.in_(['Edwardo', 'fakeuser'])).all() <br />UPDATE users SET name=? WHERE users.id = ?<br />('Edwardo', 1)<br />INSERT INTO users (name, fullname, password) VALUES (?, ?, ?)<br />('fakeuser', 'Invalid', '12345')<br />SELECT users.id AS users_id,<br />        users.name AS users_name,<br />        users.fullname AS users_fullname,<br />        users.password AS users_password<br />FROM users<br />WHERE users.name IN (?, ?)<br />('Edwardo', 'fakeuser')<br />[&lt;User('Edwardo','Ed Jones', 'f8s7ccs')&gt;, &lt;User('fakeuser','Invalid', '12345')&gt;]</p>
<p>好吧，接下来是见证奇迹的时刻，我们回滚(rolling back)事务：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.rollback()<br />ROLLBACK<br />&gt;&gt;&gt; ed_user.name <br />BEGIN (implicit)<br />SELECT users.id AS users_id,<br />        users.name AS users_name,<br />        users.fullname AS users_fullname,<br />        users.password AS users_password<br />FROM users<br />WHERE users.id = ?<br />(1,)<br />u'ed'<br />&gt;&gt;&gt; fake_user in session<br />False</p>
<p>我们可以看到ed_user的名字变回ed，并且我们不期望的用户fake_user被“踢出”会话(Session)了。</p>
<p>最后，我们可以查询一下用户名在['ed', 'fakeuser']范围的用户，确保我们的更改是有效的：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&gt;&gt;&gt; session.query(User).filter(User.name.in_(['ed', 'fakeuser'])).all()<br />SELECT users.id AS users_id,<br />        users.name AS users_name,<br />        users.fullname AS users_fullname,<br />        users.password AS users_password<br />FROM users<br />WHERE users.name IN (?, ?)<br />('ed', 'fakeuser')<br />[&lt;User('ed','Ed Jones', 'f8s7ccs')&gt;]</p>
<p>好了，今天就到这里，今天我们讲解了添加对象和事务回滚，或多或少穿插了些简单的查询，接下来我们会介绍较为复杂一些的查询语句，敬请期待！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-14 16:03:14</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/sqlalchemy/" title="sqlalchemy">sqlalchemy</a>, <a href="https://www.iamivan.net/tag/%e4%ba%8b%e5%8a%a1%e5%9b%9e%e6%bb%9a/" title="事务回滚">事务回滚</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e6%b7%bb%e5%8a%a0/" title="数据添加">数据添加</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Python ORM框架SQLAlchemy学习笔记之数据添加和事务回滚介绍_python的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Yd3Jb.html" rel="bookmark">Python ORM框架SQLAlchemy学习笔记之数据查询实例&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前期我们做了充足的准备工作,现在该是关键内容之一查询了,当然前面的文章中或多或少的穿插了些有关查询的东西,比如一个查询(Query)对象就是通过Session会话的query()方法获取的,需要注意的是这个方法的参数数目是可变的,也就是说我们可以传入任意多的参数数目,参数的类型可以是任意的类组合或者是类的名称,接下来我们的例子就说明了这一点,我们让Query对象加载了User实例. 复制代码 代码如下: &gt;&gt;&gt; for instance in session.query(User).or			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrGVlp.html" rel="bookmark">Python ORM框架SQLAlchemy学习笔记之安装和简单查询实例&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近正好在寻求一种Python的数据库ORM (Object Relational Mapper),SQLAlchemy (项目主页)这个开源项目进入了我的视线,本来想尝试着使用Django的ORM模块的,无奈Django的模块联系比较紧密,没能单独分拆下来,一定程度上说明Django自成体系的生态系统在给我们带来快速便捷的开发环境的同时牺牲了组装的灵活性. 初次学习,也没实质感觉到SQLAlchemy的好处,不过看其介绍的很多大公司均采用该项目,而且其支持的数据库还是蛮丰富的,所以我觉得花点时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj8YW0p.html" rel="bookmark">Python ORM框架SQLAlchemy学习笔记之映射类使用实例和Session会话介绍&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 创建映射类的实例(Instance) 前面介绍了如何将数据库实体表映射到Python类上,下面我们可以创建这个类的一个实例(Instance),我们还是以前一篇文章的User类为例,让我们创建User对象: 复制代码 代码如下: &gt;&gt;&gt; ed_user = User('ed', 'Ed Jones', 'edspassword')&gt;&gt;&gt; ed_user.name'ed'&gt;&gt;&gt; ed_user.password'edspassword'&gt;&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAAmQZM.html" rel="bookmark">MySQL学习笔记之数据的增、删、改实现方法&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了MySQL学习笔记之数据的增.删.改实现方法.分享给大家供大家参考,具体如下: 一.增加数据 插入代码格式: insert into 表明 [列名-] values (值-) create table test21(name varchar(32)); insert into test21 (name) values ('huangbiao'); 插入原则: 1.插入的数据应与字段的数据类型相同 2.数据的大小应该在列的规定范围内 3.在values中列出的数据位置必须与被加入的列			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyBDdz.html" rel="bookmark">Windows phone 8 学习笔记&lpar;2&rpar; 数据文件操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Windows phone 8 学习笔记(2) 数据文件操作 Windows phone 8 应用用于数据文件存储访问的位置仅仅限于安装文件夹.本地文件夹(独立存储空间).媒体库和SD卡四个地方.本节主要讲解它们的用法以及相关限制性.另外包括本地数据库的使用方式. 快速导航:     一.分析各类数据文件存储方式     二.安装文件夹     三.本地文件夹(独立存储空间)     四.媒体库操作     五.本地数据库 一.分析各类数据文件存储方式 1)安装文件夹 安装文件夹即应用安装			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL53l5z.html" rel="bookmark">MySQL学习笔记之数据定义表约束&comma;分页方法总结&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了MySQL学习笔记之数据定义表约束,分页方法.分享给大家供大家参考,具体如下: 1. primary key 主键 特点:主键是用于唯一标识一条记录的约束,一张表最多只能有一个主键,不能为空也不能重复 create table user1(id int primary key,name varchar(32)); mysql&gt; insert into user1 values(1,'hb'); Query OK, 1 row affected (0.10 sec) mysql&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQrmjQM.html" rel="bookmark">java hibernate-紧急！！：hibernate学习中，数据添加不仅数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 紧急!!:hibernate学习中,数据添加不仅数据库 Exception in thread &quot;&quot;main&quot;&quot; org.hibernate.exception.GenericJDBCException: could not insert: [com.test.hibernate.domain.User] at org.hibernate.exception.SQLStateConverter.handledNonSpecificException(SQL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRVoZp.html" rel="bookmark">spring学习笔记&lpar;24&rpar;基于注解配置事务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用注解的方式配置事务极为便利,在xml文件上只需声明我们的注解,然后即可直接在相应service类通过标注注解来完成事务配置.相对于配置在xml文件,简洁了需要,但配置信息分散,会导致易读性大大减弱. 使用步骤: 1. 在spring容器中注册注解搜索器 目的是使分散在各业务类中的注解得以生效 &lt;!-- 使用annotation定义事务 --&gt; &lt;tx:annotation-driven transaction-manager=&quot;transactionManager&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJrOvp.html" rel="bookmark">插入多条数据回滚-hibernate 手动控制事务回滚失败</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 hibernate 手动控制事务回滚失败 spring配置: 5201005100 &lt;bean id=&quot;sessionFactory&quot; class=&quot;org.springframework.orm.hibernate3.annotation.AnnotationSessionFactoryBean&quot;&gt; &lt;property name=&quot;dataSource&quot; ref=&quot;dataSource&quot; /&gt			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyPWPb.html" rel="bookmark" class="title">Active Server Pages ＋ 介绍</a>
					<div>
						active|server ASP+ 被设计成与以前版本的ASP的向下兼容,在某些情况下只需要一些小的改变.你可以在现有 Windows 2000 服务器上,将ASP+与ASP安装在一起.这就允许你实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeK90M.html" rel="bookmark" class="title">PHP开发中接收复选框信息的方法</a>
					<div>
						复选框     PHP接收多个同名复选框信息不像ASP那样自动转换成为数组,这给使用带来了一定不便.但是还是有解决办法的,就是利用javascript做一下预处理.多个同名复选框在javascript ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg063p.html" rel="bookmark" class="title">如何在MSSQL执行命令</a>
					<div>
						假设一台主机开了1433端口我们已通过SQL注入或是空弱密码远程连接 能有哪些办法加一个系统管理员用户呢(或是执行系统命令) 1).XP_CMDSHELL 'cmd.exe /c net user a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM90nob.html" rel="bookmark" class="title">PHP中的XML应用&lpar;一&rpar;</a>
					<div>
						xml 综述 XML代表Extensible Markup Language(eXtensible Markup Language的缩写,意为可扩展的标记语言).XML是一套定义语义标记的规则,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzV11Qp.html" rel="bookmark" class="title">Alpha和索引色透明</a>
					<div>
						索引|透明 &quot;在透明背景下我无法在预览中看到白色.只要我一转换到透明色,所有的白色就变成透明.如果我设置为不透明,本来和背景色相同的物体就会变成白色.&quot; -- M 我想跟随我一起用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEBvZM.html" rel="bookmark" class="title">网页中实现套打的解决办法</a>
					<div>
						解决|网页 &lt;% rem 文章标题:关于网页中实现套打的解决办法 rem 作者:yanek rem 联系:aspboy@263.net %&gt; 1.制作一个简单网页,其中只包含一个元素..  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB22Z9b.html" rel="bookmark" class="title">php页面间传值的例子</a>
					<div>
						例如: A.php &lt;?php $usernane ?&gt; 要将A.php中的$usernane值传给另外一个页面(B.php)中的实现方法: &lt;meta   http-equiv=' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK0Qvp.html" rel="bookmark" class="title">GPRS&sol;UMTS分组域漫游</a>
					<div>
						GPRS-UMTS分组域漫游在概念上与GSM漫游非常相似--通过不同地区网络或运营商之间签署的国内和国际漫游协议,允许用户在有GPRS/UMTS覆盖的地方随时接入网络.移动用户的签约业务信息被永久保存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP6yjM.html" rel="bookmark" class="title">oracle中如何删除用户</a>
					<div>
						删除用户,可以使用drop user命令,如下所示: drop user user01; 如果用户拥有对象,则不能直接删除,否则将返回一个错误值.指定关键字cascade,可删除用户所有的对象,然后再 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA836b.html" rel="bookmark" class="title">Java相对路径与绝对路径的问题</a>
					<div>
						 在写java程序时不可避免要获取文件的路径-总结一下,遗漏的随时补上     1.可以在servlet的init方法里     String path = getServletContext().g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjB7Wb.html" rel="bookmark" class="title">photoshop运行慢好卡怎么办</a>
					<div>
						  众所周知Photoshop很占内存,内存不够时还会自动启用缓存盘,电脑就变得卡顿无比.当然这其中有一部分原因是电脑性能不足,另一部分则是Photoshop&quot;有多少用多少&quot;工作原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9E2wXM.html" rel="bookmark" class="title">如何将硬盘分区分成整数</a>
					<div>
						在我们分区的时候,相信大家都是按照 1GB = 1024MB 这个标准公式来算的.但是实际上,在分区时直接套用这个公式是不正确的. 当然,我们只需要套用下面这个公式,分区就可以完美分出整数数值了. 这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7096b.html" rel="bookmark" class="title">xplorer2是什么？</a>
					<div>
						  xplorer2 是2xExplorer的后续版本,xplorer2拥有全新的界面,和系统的资源管理器一模一样的操作,让你不用学习即可快速上手. xplorer2体积小巧,仅仅功能却很丰富,可以让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3oAjp.html" rel="bookmark" class="title">Win7系统怎样禁用没用的服务项以提升效率</a>
					<div>
						  最新win7系统下载之后,由于用户安装软件以及各种各样的问题,导致了目前系统运行速度越来越慢的情况,所以面对这样的情况,就希望各位用户可以自行禁用无用服务,以此来提高系统的运行效率,以下便是相关的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWyX9p.html" rel="bookmark" class="title">17寸最新游戏本华硕G750测评</a>
					<div>
						  随着英特尔第四代酷睿处理器Haswell的上市,PC厂商也开始有条不紊地发布新产品或是更新旗下已有的型号.其中,在2013台北电脑展上,华硕展示了新款G750游戏本,一个明显的变化是取消了14及1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYRB0b.html" rel="bookmark" class="title">苹果发布会2015</a>
					<div>
						  苹果发布会2015年3月9日开特别发布会:宣布Apple Watch上市!北京时间2月27日凌晨消息,苹果公司周四发出邀请函,邀请媒体界人士出席定于3月9日召开的一次特别发布会. 该发布会将于旧金 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdV66M.html" rel="bookmark" class="title">精确度量Linux下进程占用多少内存的方法</a>
					<div>
						在Linux中,要了解进程的信息,莫过于从 proc 文件系统中入手去看.proc的详细介绍,可以参考内核文档的解读,里面有很多内容 yum install -y kernel-doc cat /us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG52ab.html" rel="bookmark" class="title">对象</a>
					<div>
						问题描述 代码:classProgram{staticvoidMain(string[]args){bb1=newb();aa1=b1;a1.f();a1.g();b1.f();b1.g();Cons ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bam812b.html" rel="bookmark" class="title">音视频封装格式和编码格式</a>
					<div>
						音视频封装格式.编码格式知识        常见的AVI.RMVB.MKV.ASF.WMV.MP4.3GP.FLV等文件其实只能算是一种封装标准. 一个完整的视频文件是由音频和视频2部分组成的.H26 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAD33M.html" rel="bookmark" class="title">仿网易新闻页面效果</a>
					<div>
						不扯闲话了,直接进入正题吧 frame_content.xml [html] view plaincopy &lt;?xml version=&quot;1.0&quot; encoding=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwrlQM.html" rel="bookmark" class="title">网页浏览器知道我们的哪些信息？&lpar;2&rpar;</a>
					<div>
						[编者按]本文最早发布于 SecureMac 博客,其第一部分介绍了网络浏览器存储了哪些用户数据.在第二部分,将解释这些数据对用户的隐私有何影响.本文系国内 ITOM 管理平台 OneAPM 编译呈现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr8K1M.html" rel="bookmark" class="title">MATLAB7&period;0安装后，启动弹出找不到指定的模块</a>
					<div>
						安装MATLAB7.0途中用遇到了如下的问题: 先是找不到指定模块.确定后,找不到指定程序ddot.确定后,Default Charset: ibm-1386_P100-2002Register St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQ5Knp.html" rel="bookmark" class="title">请求-请教一个关于CKEditor的问题，急！</a>
					<div>
						问题描述 请教一个关于CKEditor的问题,急! 我用的是primefaces的ckeditor组件, 应该对应的是ckeditor 3点几的版本. 现在需要这么一个功能: 复制外部html内容按c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZRERz.html" rel="bookmark" class="title">在winfrom设计中listview的滚动条如何改变颜色</a>
					<div>
						问题描述 在winfrom设计中listview的滚动条如何改变颜色 在网上找到了代码 protected override void OnPaint(PaintEventArgs e) { //Re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Am2Bz.html" rel="bookmark" class="title">Win2008 r2服务器配置VPN服务器教程&lpar;图文详解&rpar;&lowbar;win服务器</a>
					<div>
						系统环境:WindowsServer2008R2Enterprise(完全安装) 1.配置准备工作 1.1.点击&quot;开始&quot;右边的&quot;服务器管理器&quot; 1.2.在&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB5kqb.html" rel="bookmark" class="title">ORACLE数据库SQL语句的执行过程</a>
					<div>
						SQL语句在 数据库中处理过程是怎样的呢?执行顺序呢?在回答这个问题前,我们先来回顾一下:在ORACLE数据库系统架构下,SQL语句由用户进程产生,然后传到相 对应的服务端进程,之后由服务器进程执行该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAN6eM.html" rel="bookmark" class="title">&lpar;R&rpar;&quest;ex 0&period;12&period;1发布 服务器管理工具</a>
					<div>
						(R)?ex http://www.aliyun.com/zixun/aggregation/37104.html&quot;&gt;0.12.1此版本解决了特殊字符模板模块中的一个错误. (R)?e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YY7lz.html" rel="bookmark" class="title">Java 实现单例的难点</a>
					<div>
						有简单又高效的方法可以实现单例模式,但没有一种方式能在任何情况下都确保单例的完整性. 单例模式是指某个类只被实例化一次,用来表示全局或系统范围的组件.单例模式常用于日志记录.工厂.窗口管理器和平台组件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqGm2p.html" rel="bookmark" class="title">linux操作系统-linux系统能识别哪些usb网卡的芯片</a>
					<div>
						问题描述 linux系统能识别哪些usb网卡的芯片 linux系统能识别哪些usb网卡的芯片 linux系统能识别哪些usb网卡的芯片 解决方案 DASDSADASDASD 解决方案二: 大部分都是可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeAWlM.html" rel="bookmark" class="title">c&plus;&plus;调用c库函数-结构体排序，自定义比较函数bool cmp&lpar;&rpar;</a>
					<div>
						问题描述 结构体排序,自定义比较函数bool cmp() C++结构体 用sort排序 自己定义比较函数cmp bool cmp() struct lzl { string s; int a,b; } ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
